summaryrefslogtreecommitdiff
path: root/sys-fs
diff options
context:
space:
mode:
authorV3n3RiX <venerix@koprulu.sector>2023-07-18 15:45:16 +0100
committerV3n3RiX <venerix@koprulu.sector>2023-07-18 15:45:16 +0100
commit5986ab5735b24557718ed7189cffd9e64c24d32a (patch)
treee5d1d8aaeb8d069da8b92166512cf07966908b73 /sys-fs
parent4bd6fd31e606d063b1b8bb8bca95ad767b7d6a2b (diff)
sys-fs/cryptsetup : version bump
Diffstat (limited to 'sys-fs')
-rw-r--r--sys-fs/cryptsetup/Manifest2
-rw-r--r--sys-fs/cryptsetup/cryptsetup-2.6.1-r5.ebuild (renamed from sys-fs/cryptsetup/cryptsetup-2.3.4-r10.ebuild)105
-rw-r--r--sys-fs/cryptsetup/files/1.6.7-dmcrypt.confd111
-rw-r--r--sys-fs/cryptsetup/files/2.4.3-dmcrypt.rc (renamed from sys-fs/cryptsetup/files/1.6.7-dmcrypt.rc)75
-rw-r--r--sys-fs/cryptsetup/files/cryptsetup-2.0.4-fix-static-pwquality-build.patch18
5 files changed, 110 insertions, 201 deletions
diff --git a/sys-fs/cryptsetup/Manifest b/sys-fs/cryptsetup/Manifest
index 96ff3e3a..12d3d773 100644
--- a/sys-fs/cryptsetup/Manifest
+++ b/sys-fs/cryptsetup/Manifest
@@ -1 +1 @@
-DIST cryptsetup-2.3.4.tar.xz 11114004 BLAKE2B 680e6eeb594737aeb8330b0ac8638e94941bdcc56fc3441b6f1bc4f3d209d768096e23a7f840dc1012f9e63fae0fdbc0e72d735d89e92a621cec88ea59560f19 SHA512 db0bfd795343e575acb7a80ea2b9d32acf08ac970037e5b158a1e4381976552dc292107ce79e55913f49fcf643d4ea7104ed73de7c1e8d424b83d471d20ab60d
+DIST cryptsetup-2.6.1.tar.xz 11402380 BLAKE2B efd7a64d89d863876de68ff3e89d8c94ad5eca6a8d2236c52c234fbe51e9d9ee303a0c7fe7dac7df10e0062003b9c0aeddc8dc342582106c157ab2d1e742155e SHA512 0cbddbf33cbac2b834ed7e2dd47a9fc787131031a1c729f373f5c974600a838097e9cc0555f13719fc79c384a2a34b404f94ba4cc2f35f0bb1d70aef2233fd18
diff --git a/sys-fs/cryptsetup/cryptsetup-2.3.4-r10.ebuild b/sys-fs/cryptsetup/cryptsetup-2.6.1-r5.ebuild
index 70488f8e..0b2fdcb1 100644
--- a/sys-fs/cryptsetup/cryptsetup-2.3.4-r10.ebuild
+++ b/sys-fs/cryptsetup/cryptsetup-2.6.1-r5.ebuild
@@ -1,56 +1,66 @@
-# Copyright 1999-2020 Gentoo Authors
+# Copyright 1999-2023 Gentoo Authors
# Distributed under the terms of the GNU General Public License v2
-EAPI=7
+EAPI=8
-inherit autotools linux-info libtool
+inherit linux-info tmpfiles
DESCRIPTION="Tool to setup encrypted devices with dm-crypt"
-HOMEPAGE="https://gitlab.com/cryptsetup/cryptsetup/blob/master/README.md"
+HOMEPAGE="https://gitlab.com/cryptsetup/cryptsetup"
SRC_URI="https://www.kernel.org/pub/linux/utils/${PN}/v$(ver_cut 1-2)/${P/_/-}.tar.xz"
+S="${WORKDIR}"/${P/_/-}
LICENSE="GPL-2+"
SLOT="0/12" # libcryptsetup.so version
-[[ ${PV} != *_rc* ]] && \
-KEYWORDS="~alpha ~amd64 ~arm ~arm64 ~hppa ~ia64 ~mips ~ppc ~ppc64 ~riscv ~s390 ~sparc ~x86"
+if [[ ${PV} != *_rc* ]] ; then
+ KEYWORDS="~alpha amd64 arm arm64 hppa ~ia64 ~loong ~mips ppc ppc64 ~riscv ~s390 sparc x86"
+fi
+
CRYPTO_BACKENDS="gcrypt kernel nettle +openssl"
# we don't support nss since it doesn't allow cryptsetup to be built statically
# and it's missing ripemd160 support so it can't provide full backward compatibility
-IUSE="${CRYPTO_BACKENDS} +argon2 libressl nls pwquality reencrypt static static-libs +udev urandom"
-REQUIRED_USE="^^ ( ${CRYPTO_BACKENDS//+/} )
- libressl? ( openssl )
- static? ( !gcrypt )" #496612
+IUSE="${CRYPTO_BACKENDS} +argon2 fips nls pwquality ssh static static-libs test +udev urandom"
+RESTRICT="!test? ( test )"
+# bug #496612, bug #832711, bug #843863
+REQUIRED_USE="
+ ^^ ( ${CRYPTO_BACKENDS//+/} )
+ static? ( !gcrypt !ssh !udev !fips )
+ fips? ( !kernel !nettle )
+"
LIB_DEPEND="
dev-libs/json-c:=[static-libs(+)]
- dev-libs/libgpg-error[static-libs(+)]
dev-libs/popt[static-libs(+)]
>=sys-apps/util-linux-2.31-r1[static-libs(+)]
argon2? ( app-crypt/argon2:=[static-libs(+)] )
- gcrypt? ( dev-libs/libgcrypt:0=[static-libs(+)] )
- nettle? ( >=dev-libs/nettle-2.4[static-libs(+)] )
- openssl? (
- !libressl? ( dev-libs/openssl:0=[static-libs(+)] )
- libressl? ( dev-libs/libressl:0=[static-libs(+)] )
+ gcrypt? (
+ dev-libs/libgcrypt:0=[static-libs(+)]
+ dev-libs/libgpg-error[static-libs(+)]
)
+ nettle? ( >=dev-libs/nettle-2.4[static-libs(+)] )
+ openssl? ( dev-libs/openssl:0=[static-libs(+)] )
pwquality? ( dev-libs/libpwquality[static-libs(+)] )
+ ssh? ( net-libs/libssh[static-libs(+)] )
sys-fs/lvm2[static-libs(+)]
- udev? ( virtual/libudev[static-libs(-)] )"
+"
# We have to always depend on ${LIB_DEPEND} rather than put behind
# !static? () because we provide a shared library which links against
-# these other packages. #414665
-RDEPEND="static-libs? ( ${LIB_DEPEND} )
- ${LIB_DEPEND//\[static-libs\([+-]\)\]}"
-DEPEND="${RDEPEND}
- static? ( ${LIB_DEPEND} )"
+# these other packages. bug #414665
+RDEPEND="
+ static-libs? ( ${LIB_DEPEND} )
+ ${LIB_DEPEND//\[static-libs\([+-]\)\]}
+ udev? ( virtual/libudev:= )
+"
+DEPEND="
+ ${RDEPEND}
+ static? ( ${LIB_DEPEND} )
+"
+# vim-core needed for xxd in tests
BDEPEND="
virtual/pkgconfig
+ test? ( app-editors/vim-core )
"
-S="${WORKDIR}/${P/_/-}"
-
-PATCHES=( "${FILESDIR}"/${PN}-2.0.4-fix-static-pwquality-build.patch )
-
pkg_setup() {
local CONFIG_CHECK="~DM_CRYPT ~CRYPTO ~CRYPTO_CBC ~CRYPTO_SHA256"
local WARNING_DM_CRYPT="CONFIG_DM_CRYPT:\tis not set (required for cryptsetup)\n"
@@ -61,22 +71,17 @@ pkg_setup() {
}
src_prepare() {
- sed -i '/^LOOPDEV=/s:$: || exit 0:' tests/{compat,mode}-test || die
default
- eautoreconf
+
+ sed -i '/^LOOPDEV=/s:$: || exit 0:' tests/{compat,mode}-test || die
}
src_configure() {
- if use kernel ; then
- ewarn "Note that kernel backend is very slow for this type of operation"
- ewarn "and is provided mainly for embedded systems wanting to avoid"
- ewarn "userspace crypto libraries."
- fi
-
local myeconfargs=(
--disable-internal-argon2
+ --disable-asciidoc
--enable-shared
- --sbindir=/sbin
+ --sbindir="${EPREFIX}"/sbin
# for later use
--with-default-luks-format=LUKS1
--with-tmpfilesdir="${EPREFIX}/usr/lib/tmpfiles.d"
@@ -84,12 +89,16 @@ src_configure() {
$(use_enable argon2 libargon2)
$(use_enable nls)
$(use_enable pwquality)
- $(use_enable reencrypt cryptsetup-reencrypt)
+ $(use_enable !static external-tokens)
$(use_enable static static-cryptsetup)
$(use_enable static-libs static)
$(use_enable udev)
$(use_enable !urandom dev-random)
+ $(use_enable ssh ssh-token)
+ $(usev !argon2 '--with-luks2-pbkdf=pbkdf2')
+ $(use_enable fips)
)
+
econf "${myeconfargs[@]}"
}
@@ -113,26 +122,26 @@ src_install() {
if use static ; then
mv "${ED}"/sbin/cryptsetup{.static,} || die
mv "${ED}"/sbin/veritysetup{.static,} || die
- if use reencrypt ; then
- mv "${ED}"/sbin/cryptsetup-reencrypt{.static,} || die
+ mv "${ED}"/sbin/integritysetup{.static,} || die
+
+ if use ssh ; then
+ mv "${ED}"/sbin/cryptsetup-ssh{.static,} || die
fi
fi
+
find "${ED}" -type f -name "*.la" -delete || die
dodoc docs/v*ReleaseNotes
- newconfd "${FILESDIR}"/1.6.7-dmcrypt.confd dmcrypt.stub
- newinitd "${FILESDIR}"/1.6.7-dmcrypt.rc dmcrypt
-}
-
-pkg_preinst() {
- if [[ -f ""${ROOT}"etc/conf.d/dmcrypt" ]]; then
- mv ""${ROOT}"etc/conf.d/dmcrypt" ""${ROOT}"etc/conf.d/dmcrypt.bak"
- fi
+ newinitd "${FILESDIR}"/2.4.3-dmcrypt.rc dmcrypt
}
pkg_postinst() {
- if [[ -f ""${ROOT}"etc/conf.d/dmcrypt.bak" ]]; then
- mv ""${ROOT}"etc/conf.d/dmcrypt.bak" ""${ROOT}"etc/conf.d/dmcrypt"
+ tmpfiles_process cryptsetup.conf
+
+ if use kernel ; then
+ ewarn "Note that kernel backend is very slow for this type of operation"
+ ewarn "and is provided mainly for embedded systems wanting to avoid"
+ ewarn "userspace crypto libraries."
fi
}
diff --git a/sys-fs/cryptsetup/files/1.6.7-dmcrypt.confd b/sys-fs/cryptsetup/files/1.6.7-dmcrypt.confd
deleted file mode 100644
index 642ff087..00000000
--- a/sys-fs/cryptsetup/files/1.6.7-dmcrypt.confd
+++ /dev/null
@@ -1,111 +0,0 @@
-# /etc/conf.d/dmcrypt
-
-# For people who run dmcrypt on top of some other layer (like raid),
-# use rc_need to specify that requirement. See the runscript(8) man
-# page for more information.
-
-#--------------------
-# Instructions
-#--------------------
-
-# Note regarding the syntax of this file. This file is *almost* bash,
-# but each line is evaluated separately. Separate swaps/targets can be
-# specified. The init-script which reads this file assumes that a
-# swap= or target= line starts a new section, similar to lilo or grub
-# configuration.
-
-# Note when using gpg keys and /usr on a separate partition, you will
-# have to copy /usr/bin/gpg to /bin/gpg so that it will work properly
-# and ensure that gpg has been compiled statically.
-# See http://bugs.gentoo.org/90482 for more information.
-
-# Note that the init-script which reads this file detects whether your
-# partition is LUKS or not. No mkfs is run unless you specify a makefs
-# option.
-
-# Global options:
-#----------------
-
-# How long to wait for each timeout (in seconds).
-dmcrypt_key_timeout=1
-
-# Max number of checks to perform (see dmcrypt_key_timeout).
-#dmcrypt_max_timeout=300
-
-# Number of password retries.
-dmcrypt_retries=5
-
-# Arguments:
-#-----------
-# target=<name> == Mapping name for partition.
-# swap=<name> == Mapping name for swap partition.
-# source='<dev>' == Real device for partition.
-# Note: You can (and should) specify a tag like UUID
-# for blkid (see -t option). This is safer than using
-# the full path to the device.
-# key='</path/to/keyfile>[:<mode>]' == Fullpath from / or from inside removable media.
-# remdev='<dev>' == Device that will be assigned to removable media.
-# gpg_options='<opts>' == Default are --quiet --decrypt
-# options='<opts>' == cryptsetup, for LUKS you can only use --readonly
-# loop_file='<file>' == Loopback file.
-# Note: If you omit $source, then a free loopback will
-# be looked up automatically.
-# pre_mount='cmds' == commands to execute before mounting partition.
-# post_mount='cmds' == commands to execute after mounting partition.
-#-----------
-# Supported Modes
-# gpg == decrypt and pipe key into cryptsetup.
-# Note: new-line character must not be part of key.
-# Command to erase \n char: 'cat key | tr -d '\n' > cleanKey'
-
-#--------------------
-# dm-crypt examples
-#--------------------
-
-## swap
-# Swap partitions. These should come first so that no keys make their
-# way into unencrypted swap.
-# If no options are given, they will default to: -c aes -h sha1 -d /dev/urandom
-# If no makefs is given then mkswap will be assumed
-#swap=crypt-swap
-#source='/dev/hda2'
-
-## /home with passphrase
-#target=crypt-home
-#source='/dev/hda5'
-
-## /home with regular keyfile
-#target=crypt-home
-#source='/dev/hda5'
-#key='/full/path/to/homekey'
-
-## /home with gpg protected key
-#target=crypt-home
-#source='/dev/hda5'
-#key='/full/path/to/homekey:gpg'
-
-## /home with regular keyfile on removable media(such as usb-stick)
-#target=crypt-home
-#source='/dev/hda5'
-#key='/full/path/to/homekey'
-#remdev='/dev/sda1'
-
-## /home with gpg protected key on removable media(such as usb-stick)
-#target=crypt-home
-#source='/dev/hda5'
-#key='/full/path/to/homekey:gpg'
-#remdev='/dev/sda1'
-
-## /tmp with regular keyfile
-#target=crypt-tmp
-#source='/dev/hda6'
-#key='/full/path/to/tmpkey'
-#pre_mount='/sbin/mkreiserfs -f -f ${dev}'
-#post_mount='chown root:root ${mount_point}; chmod 1777 ${mount_point}'
-
-## Loopback file example
-#target='crypt-loop-home'
-#source='/dev/loop0'
-#loop_file='/mnt/crypt/home'
-
-# The file must be terminated by a newline. Or leave this comment last.
diff --git a/sys-fs/cryptsetup/files/1.6.7-dmcrypt.rc b/sys-fs/cryptsetup/files/2.4.3-dmcrypt.rc
index cdd20ba9..ea9a5ca4 100644
--- a/sys-fs/cryptsetup/files/1.6.7-dmcrypt.rc
+++ b/sys-fs/cryptsetup/files/2.4.3-dmcrypt.rc
@@ -3,7 +3,9 @@
# Distributed under the terms of the GNU General Public License v2
depend() {
+ use modules
before checkfs fsck
+ after dev-settle
if grep -qs ^swap= "${conf_file}" ; then
before swap
@@ -21,7 +23,7 @@ fi
# Setup mappings for an individual target/swap
# Note: This relies on variables localized in the main body below.
dm_crypt_execute() {
- local dev ret mode foo
+ local dev ret mode foo source_dev
if [ -z "${target}" -a -z "${swap}" ] ; then
return
@@ -31,6 +33,7 @@ dm_crypt_execute() {
: ${dmcrypt_key_timeout:=1}
: ${dmcrypt_max_timeout:=300}
: ${dmcrypt_retries:=5}
+ : ${wait:=5}
# Handle automatic look up of the source path.
if [ -z "${source}" -a -n "${loop_file}" ] ; then
@@ -38,7 +41,16 @@ dm_crypt_execute() {
fi
case ${source} in
*=*)
- source=$(blkid -l -t "${source}" -o device)
+ i=0
+ while [ ${i} -lt ${wait} ]; do
+ if source_dev="$(blkid -l -t "${source}" -o device)"; then
+ source="${source_dev}"
+ break
+ fi
+ : $((i += 1))
+ einfo "waiting for source \"${source}\" for ${target}..."
+ sleep 1
+ done
;;
esac
if [ -z "${source}" ] || [ ! -e "${source}" ] ; then
@@ -46,11 +58,28 @@ dm_crypt_execute() {
return
fi
+ if [ -n "${header}" ] ; then
+ header_opt="--header=${header}"
+
+ i=0
+ while [ ! -e "${header}" ] && [ ${i} -lt ${wait} ] ; do
+ : $((i += 1))
+ einfo "Waiting for header ${header} to appear for ${target} ${i}/${dmcrypt_max_timeout} ..."
+ sleep 1
+ done
+ if [ ${i} -gt ${wait} ] || [ ${i} -eq ${wait} ] ; then
+ ewarn "Waited ${i} times for header file ${header}. Aborting ${target}."
+ return
+ fi
+ else
+ header_opt=""
+ fi
+
if [ -n "${target}" ] ; then
# let user set options, otherwise leave empty
: ${options:=' '}
elif [ -n "${swap}" ] ; then
- if cryptsetup isLuks ${source} 2>/dev/null ; then
+ if cryptsetup ${header_opt} isLuks ${source} 2>/dev/null ; then
ewarn "The swap you have defined is a LUKS partition. Aborting crypt-swap setup."
return
fi
@@ -71,7 +100,7 @@ dm_crypt_execute() {
# open <device> <name> # <device> is $source
# create <name> <device> # <name> is $target
local arg1="create" arg2="${target}" arg3="${source}"
- if cryptsetup isLuks ${source} 2>/dev/null ; then
+ if cryptsetup ${header_opt} isLuks ${source} 2>/dev/null ; then
arg1="open"
arg2="${source}"
arg3="${target}"
@@ -81,7 +110,7 @@ dm_crypt_execute() {
# ${target} is active:
# Newer versions report:
# ${target} is active[ and is in use.]
- if cryptsetup status ${target} | egrep -q ' is active' ; then
+ if cryptsetup ${header_opt} status ${target} | grep -E -q ' is active' ; then
einfo "dm-crypt mapping ${target} is already configured"
return
fi
@@ -171,7 +200,7 @@ dm_crypt_execute() {
else
mode=none
fi
- ebegin " ${target} using: ${options} ${arg1} ${arg2} ${arg3}"
+ ebegin " ${target} using: ${header_opt} ${options} ${arg1} ${arg2} ${arg3}"
if [ "${mode}" = "gpg" ] ; then
: ${gpg_options:='-q -d'}
# gpg available ?
@@ -181,7 +210,7 @@ dm_crypt_execute() {
# paranoid, don't store key in a variable, pipe it so it stays very little in ram unprotected.
# save stdin stdout stderr "values"
timeout ${dmcrypt_max_timeout} gpg ${gpg_options} ${key} 2>/dev/null | \
- cryptsetup --key-file - ${options} ${arg1} ${arg2} ${arg3}
+ cryptsetup ${header_opt} --key-file - ${options} ${arg1} ${arg2} ${arg3}
ret=$?
# The timeout command exits 124 when it times out.
[ ${ret} -eq 0 -o ${ret} -eq 124 ] && break
@@ -196,11 +225,11 @@ dm_crypt_execute() {
fi
else
if [ "${mode}" = "reg" ] ; then
- cryptsetup ${options} -d ${key} ${arg1} ${arg2} ${arg3}
+ cryptsetup ${header_opt} ${options} -d ${key} ${arg1} ${arg2} ${arg3}
ret=$?
eend ${ret} "failure running cryptsetup"
else
- cryptsetup ${options} ${arg1} ${arg2} ${arg3}
+ cryptsetup ${header_opt} ${options} ${arg1} ${arg2} ${arg3}
ret=$?
eend ${ret} "failure running cryptsetup"
fi
@@ -236,7 +265,7 @@ get_bootparam_val() {
}
start() {
- local header=true cryptfs_status=0
+ local print_header=true cryptfs_status=0
local gpg_options key loop_file target targetline options pre_mount post_mount source swap remdev
local x
@@ -256,8 +285,8 @@ start() {
rc_*) continue ;;
esac
- ${header} && ebegin "Setting up dm-crypt mappings"
- header=false
+ ${print_header} && ebegin "Setting up dm-crypt mappings"
+ print_header=false
# check for the start of a new target/swap
case ${targetline} in
@@ -266,10 +295,10 @@ start() {
dm_crypt_execute
# Prepare for the next target/swap by resetting variables
- unset gpg_options key loop_file target options pre_mount post_mount source swap remdev
+ unset gpg_options key loop_file target options pre_mount post_mount source swap remdev wait header header_opt
;;
- gpg_options=*|remdev=*|key=*|loop_file=*|options=*|pre_mount=*|post_mount=*|source=*)
+ gpg_options=*|remdev=*|key=*|loop_file=*|options=*|pre_mount=*|post_mount=*|wait=*|source=*|header=*)
if [ -z "${target}${swap}" ] ; then
ewarn "Ignoring setting outside target/swap section: ${targetline}"
continue
@@ -297,14 +326,14 @@ start() {
}
stop() {
- local line header
+ local line print_header
# Break down all mappings
- header=true
- egrep "^(target|swap)=" ${conf_file} | \
+ print_header=true
+ grep -E "^(target|swap)=" ${conf_file} | \
while read line ; do
- ${header} && einfo "Removing dm-crypt mappings"
- header=false
+ ${print_header} && einfo "Removing dm-crypt mappings"
+ print_header=false
target= swap=
eval ${line}
@@ -316,16 +345,16 @@ stop() {
fi
ebegin " ${target}"
- cryptsetup remove ${target}
+ cryptsetup ${header_opt} remove ${target}
eend $?
done
# Break down loop devices
- header=true
+ print_header=true
grep '^source=./dev/loop' ${conf_file} | \
while read line ; do
- ${header} && einfo "Detaching dm-crypt loop devices"
- header=false
+ ${print_header} && einfo "Detaching dm-crypt loop devices"
+ print_header=false
source=
eval ${line}
diff --git a/sys-fs/cryptsetup/files/cryptsetup-2.0.4-fix-static-pwquality-build.patch b/sys-fs/cryptsetup/files/cryptsetup-2.0.4-fix-static-pwquality-build.patch
deleted file mode 100644
index 39524ec3..00000000
--- a/sys-fs/cryptsetup/files/cryptsetup-2.0.4-fix-static-pwquality-build.patch
+++ /dev/null
@@ -1,18 +0,0 @@
---- a/src/Makemodule.am 2018-07-31 14:32:46.000000000 +0200
-+++ b/src/Makemodule.am 2018-08-12 17:13:26.000000000 +0200
-@@ -64,6 +64,7 @@
- $(veritysetup_LDADD) \
- @CRYPTO_STATIC_LIBS@ \
- @DEVMAPPER_STATIC_LIBS@ \
-+ @PWQUALITY_STATIC_LIBS@ \
- @UUID_LIBS@
- endif
- endif
-@@ -93,6 +94,7 @@
- $(integritysetup_LDADD) \
- @CRYPTO_STATIC_LIBS@ \
- @DEVMAPPER_STATIC_LIBS@ \
-+ @PWQUALITY_STATIC_LIBS@ \
- @UUID_LIBS@
- endif
- endif